GOSUB Initialisation
' Le 22 aout 2005. Le principe de Huygens, une seule ondelette.

'*************************** BOUCLE  PRINCIPALE *******************************
DO
    GOSUB Calcul
retour:
    DO: a$ = UCASE$(INKEY$): LOOP WHILE LEN(a$)'        Vider le tampon.
    DO: a$ = UCASE$(INKEY$): LOOP UNTIL LEN(a$)'        Attendre une action.
    IF a$ = CHR$(27) THEN END'                          Sortie.
    IF a$ = "A" THEN  ELSE GOTO retour'                 Image suivante.
    image% = image% + 1: IF image% > images% THEN image% = 1
LOOP

'**************************** CALCUL DE L'ONDE *******************************
Calcul:
LINE (0, 0)-(639, 479), 6, BF'                          Fond gris.
LINE (0, 430)-(300, 479), 0, BF'                        Fenetre de texte.
LOCATE 28, 2: PRINT "Image No."; image%; "/"; images%
LOCATE 29, 2: PRINT "Image suivante: appuyez sur  A .";
LOCATE 30, 2: PRINT "Pour quitter, appuyez sur  Echap .";
amplitudeSinus# = 0#'                               Initialiser.
amplitudeCosinus# = 0#
periode# = image% * 2# * pi# / images%'             Periode selon l'image. 

FOR x& = 0 TO largeur%'                             coordonnee x du pixel.
    x# = x& - xOnde1%'                              distance, axe horizontal.
    xCarre# = x# * x#'                              carr toujours positif.
    FOR y& = 0 TO hauteur%'                         coordonnee y du pixel.
        y# = y& - yOnde1%'                          distance, axe vertical.
        diagonale# = SQR(y# * y# + xCarre#)'        distance selon Pythagore.
        ondes# = diagonale# / lambda#'              en longueurs d'onde.
        entier% = ondes#'                           supprimer les decimales.
        differenceDeMarche# = ondes# - entier%'     difference de marche.
        IF diagonale# > lambda# / 2# THEN '         normaliser le centre.
            affaiblissement# = lambda# / 2# / diagonale#
            ELSE ' esthetique, mais aussi eviter la division par zero.
                x# = ondes# * 2#'                   formule de l'electron:
                affaiblissement# = 2# / (x# ^ 2# + 1#)
            END IF
        phase# = 2# * pi# * differenceDeMarche# - periode#' phase en radians.
        amplitudeSinus# = affaiblissement# * SIN(phase#)'   amplitude.
        amplitudeCosinus# = affaiblissement# * COS(phase#)' quadrature.
        GOSUB affichePixel'                                 vers l'affichage.
    NEXT y&
    IF LEN(INKEY$) THEN EXIT FOR
NEXT x&
RETURN


'************************** AFFICHER LE DIAGRAMME ****************************

affichePixel:              
amplitude = -amplitudeCosinus#'             inverser les couleurs.
amplitude = 3 * amplitude'                  augmenter le contraste.
amplitude = amplitude + 1'                  deporter du cote positif.
couleur = amplitude * 7.5'                  = 15 plus couleur 0 = 16 couleurs.
couleur1 = couleur - .375'                  obtenir 64 tons par diffusion.
couleur2 = couleur - .125
couleur3 = couleur + .125
couleur4 = couleur + .375
'                                           diffusion sur 4 pixels.
IF x& MOD 2 THEN
    IF y& MOD 2 THEN couleur = couleur1 ELSE couleur = couleur4
    ELSE
    IF y& MOD 2 THEN couleur = couleur3 ELSE couleur = couleur2
END IF

couleur = couleur + .3 * RND - .3 * RND'    estomper au hasard.
IF couleur > 15 THEN couleur = 15
IF couleur < 0 THEN couleur = 0
coul% = couleur'                            entier, 16 couleurs.
PSET (x&, y&), coul%'                       afficher les ondelettes.
IF y& = yOnde1% THEN '                      amplitude selon Pythagore:
    amplitude = 29 * SQR(amplitudeSinus# * amplitudeSinus# + amplitudeCosinus# * amplitudeCosinus#)
    LINE (x&, yCourbe% - amplitude)-(x&, yCourbe% + amplitude), 0
    y% = 29 * amplitudeCosinus#'            courbe de l'onde sur 29 pixels.
    IF x& = 0 THEN yPrec% = y%
    LINE (x& - 1, yCourbe% - yPrec%)-(x&, yCourbe% - y%), 15
    yPrec% = y%
END IF
RETURN

'***************************** INITIALISATION ********************************
Initialisation: '                           variables en double precision (#).
pi# = 4# * ATN(1#)'                         16 chiffres significatifs.
lambda# = 32#'                              longueur d'onde.
images% = 16'                               nombre d'images par periode.
largeur% = 639'                             dimensions de la fenetre.
hauteur% = 200
xOnde1% = 50'                               coordonnees de l'onde No. 1.
yOnde1% = hauteur% / 2
yCourbe% = hauteur% + 59'                   niveau de la courbe d'amplitude.

'********************* 16 TONS DE GRIS POUR IMAGES GIF ***********************
'       Les couleurs sont inversees pour supporter le texte en noir sur blanc.
SCREEN 12
coul% = 63'                                 64 impossible (* 4 = 256 max 255).
pas% = 4'                                   4 * 16 couleurs : crneau de 64.
FOR j% = 0 TO 15'                           palette a 16 tons de gris.
    PRINT coul%
    OUT &H3C8, j%'                          la couleur correspond a j%.
    OUT &H3C9, coul%'                       valeurs RGB identiques, donc gris.
    OUT &H3C9, coul%
    OUT &H3C9, coul%
    coul% = coul% - pas%'                   dpart  63, donc 63 - 4 = 59.
    NEXT'                                   le noir n'est pas total (= 3).
RETURN

